// You must provide a vertex and fragment shader to OpenGL.

// You have to specify the version of the shader language used.
// GLSL 1.50 is sufficient for our purposes.
#version 150 core

// This will be coming in OpenGL as a value interpolated for the fragment
// from vertex colors provided by the vertex shader.
in vec3 Color; 

out vec4 fragmentColor;

void main()
{
    // We simply pass on the incoming rgb color as opaque.
    // Color format is (red, green, blue, alpha [aka transparency: 1=opaque]).
    // Color component and alpha range is a float, 0.0f-1.0f
    fragmentColor = vec4(Color, 1.0); 
}
