#version 150 core

//page 89 + 92 green book

in vec3 Position;
in vec3 Normal;
in vec3 Color;

out vec4 fragmentColor;

void main()
{
	vec4 lightPosition = vec4(100, -100, -1000, 1.0);
	vec3 lightIntensity = vec3(1.0, 1.0, 1.0);
	
	vec3 n = normalize(Normal);
	vec3 s = normalize(vec3(lightPosition) - Position);
	vec3 v = normalize(-Position);
	vec3 r = reflect(-s, n);
	vec3 h = normalize(v + s);

	vec3 Ka = vec3(1.0, 1.0, 1.0);
	vec3 La = vec3(0.2, 0.2, 0.2);

	vec3 Ld = vec3(1.0, 1.0, 1.0);
	vec3 Kd = Color;
	
	vec3 Ks = vec3(0.1, 0.1, 0.1);
	vec3 Ls = vec3(1.0, 1.0, 1.0);
	
	vec3 ambient = La * Ka;
	float sDotN = max( dot(s, n), 0.0);
	vec3 diffuse = Ld * Kd * sDotN;
	
	vec3 spec = vec3(0.0);
	
	float Shininess = 100;
	if (sDotN > 0.0)
	{
		spec = Ls * Ks * pow(max(dot(h,n), 0.0), Shininess);
	}
	vec3 res = ambient + diffuse + spec;
	
	fragmentColor = vec4(res, 1.0); 
}
